## orocos-kdl 1.3.0%2Bdfsg

=== debian/changelog ===
orocos-kdl (1.3.0+dfsg-1) unstable; urgency=low

  [ Leopold Palomo-Avellaneda ]
  * Initial release. Closes: #783109

 -- Riku Voipio <riku.voipio@linaro.org>  Wed, 11 Nov 2015 14:57:16 +0200

## orocos-kdl 1.3.0+dfsg

=== orocos_kdl/tests/CMakeLists.txt ===
IF(ENABLE_TESTS)
  ENABLE_TESTING()

  INCLUDE_DIRECTORIES(${PROJ_SOURCE_DIR}/src ${CPPUNIT_HEADERS} ${PROJECT_BINARY_DIR}/src)

  ADD_EXECUTABLE(framestest framestest.cpp test-runner.cpp)
  TARGET_LINK_LIBRARIES(framestest orocos-kdl ${CPPUNIT})
  SET(TESTNAME "framestest")
  SET_TARGET_PROPERTIES( framestest PROPERTIES
   COMPILE_FLAGS "${CMAKE_CXX_FLAGS_ADD} ${KDL_CFLAGS} -DTESTNAME=\"\\\"${TESTNAME}\\\"\" ")
  ADD_TEST(framestest framestest)
  
 ADD_EXECUTABLE(kinfamtest kinfamtest.cpp test-runner.cpp)
 TARGET_LINK_LIBRARIES(kinfamtest orocos-kdl ${CPPUNIT})
 SET(TESTNAME "kinfamtest")
 SET_TARGET_PROPERTIES( kinfamtest PROPERTIES
  COMPILE_FLAGS "${CMAKE_CXX_FLAGS_ADD} ${KDL_CFLAGS}")
 ADD_TEST(kinfamtest kinfamtest)

 ADD_EXECUTABLE(solvertest solvertest.cpp test-runner.cpp)
 TARGET_LINK_LIBRARIES(solvertest orocos-kdl ${CPPUNIT})
 SET(TESTNAME "solvertest")
 SET_TARGET_PROPERTIES( solvertest PROPERTIES
  COMPILE_FLAGS "${CMAKE_CXX_FLAGS_ADD} ${KDL_CFLAGS} -DTESTNAME=\"\\\"${TESTNAME}\\\"\" ")
 ADD_TEST(solvertest solvertest)

 ADD_EXECUTABLE(inertiatest inertiatest.cpp test-runner.cpp)
 TARGET_LINK_LIBRARIES(inertiatest orocos-kdl ${CPPUNIT})
 SET(TESTNAME "inertiatest")
 SET_TARGET_PROPERTIES( inertiatest PROPERTIES
  COMPILE_FLAGS "${CMAKE_CXX_FLAGS_ADD} ${KDL_CFLAGS} -DTESTNAME=\"\\\"${TESTNAME}\\\"\" ")
 ADD_TEST(inertiatest inertiatest)

 ADD_EXECUTABLE(jacobiantest jacobiantest.cpp test-runner.cpp)
 SET(TESTNAME "jacobiantest")
 TARGET_LINK_LIBRARIES(jacobiantest orocos-kdl ${CPPUNIT})
 SET_TARGET_PROPERTIES( jacobiantest PROPERTIES
  COMPILE_FLAGS "${CMAKE_CXX_FLAGS_ADD} ${KDL_CFLAGS} -DTESTNAME=\"\\\"${TESTNAME}\\\"\" ")
 ADD_TEST(jacobiantest jacobiantest)

 ADD_EXECUTABLE(velocityprofiletest velocityprofiletest.cpp test-runner.cpp)
 SET(TESTNAME "velocityprofiletest")
 TARGET_LINK_LIBRARIES(velocityprofiletest orocos-kdl ${CPPUNIT})
 SET_TARGET_PROPERTIES( velocityprofiletest PROPERTIES
   COMPILE_FLAGS "${CMAKE_CXX_FLAGS_ADD} ${KDL_CFLAGS} -DTESTNAME=\"\\\"${TESTNAME}\\\"\" ")
 ADD_TEST(velocityprofiletest velocityprofiletest)

#  ADD_EXECUTABLE(rframestest  rframestest.cpp)
#  TARGET_LINK_LIBRARIES(rframestest orocos-kdl)
#  ADD_TEST(rframestest rframestest)
#
#  ADD_EXECUTABLE(rallnumbertest  rallnumbertest.cpp)
#  TARGET_LINK_LIBRARIES(rallnumbertest orocos-kdl)
#  ADD_TEST(rallnumbertest rallnumbertest)
#
#  
# IF(OROCOS_PLUGIN)
#   ADD_EXECUTABLE(toolkittest toolkittest.cpp)
#   LINK_DIRECTORIES(${OROCOS_RTT_LINK_DIRS})
#   TARGET_LINK_LIBRARIES(toolkittest orocos-kdltk orocos-kdl ${OROCOS_RTT_LIBS})
#   ADD_TEST(toolkittest toolkittest)
# ENDIF(OROCOS_PLUGIN)
#
# IF(PYTHON_BINDINGS)
#   CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/framestest.py
#     ${CMAKE_CURRENT_BINARY_DIR}/framestest.py COPY_ONLY)
#   CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/kinfamtest.py
#     ${CMAKE_CURRENT_BINARY_DIR}/kinfamtest.py COPY_ONLY)
#   CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/frameveltest.py
#     ${CMAKE_CURRENT_BINARY_DIR}/frameveltest.py COPY_ONLY)
#   CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/PyKDLtest.py
#     ${CMAKE_CURRENT_BINARY_DIR}/PyKDLtest.py COPY_ONLY)
#   ADD_TEST(PyKDLtest PyKDLtest.py)
#   
#  
# ENDIF(PYTHON_BINDINGS)
  
  ADD_CUSTOM_TARGET(check ctest -V WORKING_DIRECTORY ${PROJ_BINARY_DIR}/tests)
ENDIF(ENABLE_TESTS)

=== debian/control ===
Source: orocos-kdl
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Leopold Palomo-Avellaneda <leo@alaxarxa.net>, Riku Voipio <riku.voipio@linaro.org>
Build-Depends: debhelper (>= 9), cmake (>=2.6.0), pkg-config, libeigen3-dev
Standards-Version: 3.9.6
Section: libs
Homepage: http://www.orocos.org/kdl
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=debian-science/packages/orocos/orocos-kdl.git
Vcs-Git: git://anonscm.debian.org/debian-science/packages/orocos/orocos-kdl.git

Package: liborocos-kdl-dev
Section: libdevel
Architecture: any
Depends: liborocos-kdl1.3 (= ${binary:Version}), ${misc:Depends}
Description: Kinematics and Dynamics Library development files
 Orocos project to supply RealTime usable kinematics and dynamics code,
 it contains code for rigid body kinematics calculations and
 representations for kinematic structures and their inverse and forward
 kinematic solvers. This package contains the development files
 of the library.

Package: liborocos-kdl1.3
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Kinematics and Dynamics Library runtime
 Orocos project to supply RealTime usable kinematics and dynamics code,
 it contains code for rigid body kinematics calculations and
 representations for kinematic structures and their inverse and forward
 kinematic solvers. This package contains the library itself.

=== debian/rules ===
#!/usr/bin/make -f
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

# main packaging script based on dh7 syntax
%:
	dh $@ --buildsystem=cmake --parallel

get-orig-source:
	uscan --verbose --force-download --repack --compress xz

=== debian/watch ===
# Watch control file for uscan
version=3
#opts="uversionmangle=s/(\d)[_.+-]?((RC|rc|pre|dev|beta|alpha)[\d.]*)$/$1~$2+dfsg/" \
opts=uversionmangle=s/$/+dfsg/ \
https://github.com/orocos/orocos_kinematics_dynamics/releases .*/v(\d\S*)\.(?:tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))

## orocos-kdl 1.3.1%2Bdfsg

=== orocos_kdl/examples/CMakeLists.txt ===
IF(ENABLE_EXAMPLES)
  INCLUDE_DIRECTORIES(${PROJ_SOURCE_DIR}/src ${PROJ_SOURCE_DIR}/models ${PROJ_BINARY_DIR}/src)

  add_executable(geometry geometry.cpp )
  TARGET_LINK_LIBRARIES(geometry orocos-kdl)
  
  add_executable(trajectory_example trajectory_example.cpp )
  TARGET_LINK_LIBRARIES(trajectory_example orocos-kdl)
  
  add_executable(chainiksolverpos_lma_demo chainiksolverpos_lma_demo.cpp )
  TARGET_LINK_LIBRARIES(chainiksolverpos_lma_demo orocos-kdl orocos-kdl-models)

ENDIF(ENABLE_EXAMPLES)

=== orocos_kdl/src/CMakeLists.txt ===
FILE( GLOB_RECURSE KDL_SRCS [^.]*.cpp [^.]*.cxx)
FILE( GLOB KDL_HPPS [^.]*.hpp [^.]*.inl)

FILE( GLOB UTIL_HPPS utilities/[^.]*.h utilities/[^.]*.hpp)

INCLUDE(CheckCXXSourceCompiles)
SET(CMAKE_REQUIRED_FLAGS)
CHECK_CXX_SOURCE_COMPILES("
    #include <string>
    #include <map>
    #include <vector.hpp>

    class TreeElement;
    typedef std::map<std::string, TreeElement> SegmentMap;

    class TreeElement
    {
        TreeElement(const std::string& name): number(0) {}

    public:
        int number;
        SegmentMap::const_iterator parent;
        std::vector<SegmentMap::const_iterator> children;

        static TreeElement Root(std::string& name)
        {
            return TreeElement(name);
        }
    };

    int main()
    {
        return 0;
    }
    "
    HAVE_STL_CONTAINER_INCOMPLETE_TYPES)

if(HAVE_STL_CONTAINER_INCOMPLETE_TYPES)
    SET(KDL_USE_NEW_TREE_INTERFACE_DEFAULT Off)
ELSE(HAVE_STL_CONTAINER_INCOMPLETE_TYPES)
    SET(KDL_USE_NEW_TREE_INTERFACE_DEFAULT On)
ENDIF(HAVE_STL_CONTAINER_INCOMPLETE_TYPES)

SET(KDL_USE_NEW_TREE_INTERFACE ${KDL_USE_NEW_TREE_INTERFACE_DEFAULT} CACHE BOOL "Use the new KDL Tree interface")

#Sanity check, inform the user
IF(NOT HAVE_STL_CONTAINER_INCOMPLETE_TYPES AND NOT KDL_USE_NEW_TREE_INTERFACE)
    MESSAGE(WARNING "You have chosen to use the current Tree Interface, but your platform doesn't support containers of "
        "incomplete types, this configuration is likely invalid")
ENDIF()

#In Windows (Visual Studio) it is necessary to specify the postfix
#of the debug library name and no symbols are exported by kdl, 
#so it is necessary to compile it as a static library
IF(MSVC)
    SET(CMAKE_DEBUG_POSTFIX "d")
    SET(LIB_TYPE STATIC)
ELSE(MSVC)
    SET(LIB_TYPE SHARED)
ENDIF(MSVC)

CONFIGURE_FILE(config.h.in config.h @ONLY)

ADD_LIBRARY(orocos-kdl ${LIB_TYPE} ${KDL_SRCS} config.h)
 
SET_TARGET_PROPERTIES( orocos-kdl PROPERTIES
  SOVERSION "${KDL_VERSION_MAJOR}.${KDL_VERSION_MINOR}"
  VERSION "${KDL_VERSION}"
  COMPILE_FLAGS "${CMAKE_CXX_FLAGS_ADD} ${KDL_CFLAGS}"
  INSTALL_NAME_DIR "${CMAKE_INSTALL_PREFIX}/lib${LIB_SUFFIX}"
  PUBLIC_HEADER "${KDL_HPPS};${CMAKE_CURRENT_BINARY_DIR}/config.h"
  )

# Needed so that the generated config.h can be used
INCLUDE_DIRECTORIES(${CMAKE_CURRENT_BINARY_DIR})
TARGET_LINK_LIBRARIES(orocos-kdl ${Boost_LIBRARIES})

INSTALL(TARGETS orocos-kdl
  EXPORT OrocosKDLTargets
  ARCHIVE DESTINATION lib${LIB_SUFFIX}
  LIBRARY DESTINATION lib${LIB_SUFFIX}
  PUBLIC_HEADER DESTINATION include/kdl
)

INSTALL(FILES ${UTIL_HPPS} DESTINATION include/kdl/utilities)

# Orocos convention:
CONFIGURE_FILE( kdl.pc.in ${CMAKE_CURRENT_BINARY_DIR}/orocos-kdl.pc @ONLY)
CONFIGURE_FILE( kdl.pc.in ${CMAKE_CURRENT_BINARY_DIR}/orocos_kdl.pc @ONLY)

INSTALL(FILES ${CMAKE_CURRENT_BINARY_DIR}/orocos-kdl.pc DESTINATION lib${LIB_SUFFIX}/pkgconfig)
INSTALL(FILES ${CMAKE_CURRENT_BINARY_DIR}/orocos_kdl.pc DESTINATION lib${LIB_SUFFIX}/pkgconfig)

=== debian/changelog ===
orocos-kdl (1.3.1+dfsg-1) unstable; urgency=medium

  * New upstream version.
  * Added patch to correct version number
  * Bumped Standards-Version to 3.9.8. No changes
  * Update VCS-* fields to avoid uses-insecure-uri
  * Solve dversionmangle confusion

 -- Leopold Palomo-Avellaneda <leo@alaxarxa.net>  Tue, 28 Jun 2016 08:26:31 +0200

=== debian/watch ===
# Watch control file for uscan
version=3
#opts="uversionmangle=s/(\d)[_.+-]?((RC|rc|pre|dev|beta|alpha)[\d.]*)$/$1~$2+dfsg/" \
#opts=uversionmangle=s/$/+dfsg/ \
#https://github.com/orocos/orocos_kinematics_dynamics/releases .*/v(\d\S*)\.(?:tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))

opts=dversionmangle=s/\+dfsg//,repacksuffix=+dfsg \
https://github.com/orocos/orocos_kinematics_dynamics/releases .*/v(\d\S*)\.(?:tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))

## orocos-kdl 1.3.1+dfsg

=== orocos_kdl/CMakeLists.txt ===
#
# Test CMake version
#
CMAKE_MINIMUM_REQUIRED(VERSION 2.6)
#MARK_AS_ADVANCED( FORCE CMAKE_BACKWARDS_COMPATIBILITY )


###################################################
#                                                 #
#       Start project customization section       #
#                                                 #
###################################################

PROJECT(orocos_kdl)

SET( KDL_VERSION 1.3.0)
STRING( REGEX MATCHALL "[0-9]+" KDL_VERSIONS ${KDL_VERSION} )
LIST( GET KDL_VERSIONS 0 KDL_VERSION_MAJOR)
LIST( GET KDL_VERSIONS 1 KDL_VERSION_MINOR)
LIST( GET KDL_VERSIONS 2 KDL_VERSION_PATCH)

MESSAGE( "Orocos KDL version ${VERSION} (${KDL_VERSION_MAJOR}.${KDL_VERSION_MINOR}.${KDL_VERSION_PATCH})" )

SET( PROJ_SOURCE_DIR ${orocos_kdl_SOURCE_DIR} )
SET( PROJ_BINARY_DIR ${orocos_kdl_BINARY_DIR} )


IF(NOT CMAKE_INSTALL_PREFIX)
  SET( CMAKE_INSTALL_PREFIX /usr/local/ CACHE PATH "Installation directory" FORCE)
  MESSAGE( STATUS "Setting installation directory to ${CMAKE_INSTALL_PREFIX}" )
ENDIF(NOT CMAKE_INSTALL_PREFIX)

SET(CMAKE_VERSION "${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION}.${CMAKE_PATCH_VERSION}")


IF ( NOT CMAKE_BUILD_TYPE )
  SET(CMAKE_BUILD_TYPE Release CACHE STRING "Choose the type of build, options are: None(CMAKE_CXX_FLAGS or CMAKE_C_FLAGS used) Debug Release RelWithDebInfo MinSizeRel." FORCE)
  MESSAGE( "Setting build type to '${CMAKE_BUILD_TYPE}'" )
ELSE ( NOT CMAKE_BUILD_TYPE )
  MESSAGE( "Build type set to '${CMAKE_BUILD_TYPE}' by user." )
ENDIF ( NOT CMAKE_BUILD_TYPE )

SET( KDL_CFLAGS "")

find_package(Eigen 3 QUIET)
if(NOT Eigen_FOUND)
  include(${PROJ_SOURCE_DIR}/config/FindEigen3.cmake)
  set(Eigen_INCLUDE_DIR ${EIGEN3_INCLUDE_DIR})
endif()
include_directories(${Eigen_INCLUDE_DIR})
SET(KDL_CFLAGS "${KDL_CFLAGS} -I${Eigen_INCLUDE_DIR}")

# Check the platform STL containers capabilities
include(config/CheckSTLContainers.cmake)
CHECK_STL_CONTAINERS()

# Set the default option appropriately
if(HAVE_STL_CONTAINER_INCOMPLETE_TYPES)
    set(KDL_USE_NEW_TREE_INTERFACE_DEFAULT Off)
else(HAVE_STL_CONTAINER_INCOMPLETE_TYPES)
    set(KDL_USE_NEW_TREE_INTERFACE_DEFAULT On)
endif(HAVE_STL_CONTAINER_INCOMPLETE_TYPES)

# Allow the user to select the Tree API version to use
set(KDL_USE_NEW_TREE_INTERFACE ${KDL_USE_NEW_TREE_INTERFACE_DEFAULT} CACHE BOOL "Use the new KDL Tree interface")

# The new interface requires the use of shared pointers
if(KDL_USE_NEW_TREE_INTERFACE)
    # We need shared_ptr from boost since not all compilers are c++11 capable
    find_package(Boost REQUIRED)
    include_directories(${Boost_INCLUDE_DIRS})
    set(KDL_INCLUDE_DIRS ${Boost_INCLUDE_DIRS})
endif(KDL_USE_NEW_TREE_INTERFACE)

INCLUDE (${PROJ_SOURCE_DIR}/config/DependentOption.cmake)

OPTION(ENABLE_TESTS OFF "Enable building of tests")
IF( ENABLE_TESTS )
  # If not in standard paths, set CMAKE_xxx_PATH's in environment, eg.
  # export CMAKE_INCLUDE_PATH=/opt/local/include
  # export CMAKE_LIBRARY_PATH=/opt/local/lib
  FIND_LIBRARY(CPPUNIT cppunit)
  SET(CPPUNIT ${CPPUNIT} "dl")
  FIND_PATH(CPPUNIT_HEADERS cppunit/TestRunner.h)
  IF ( CPPUNIT AND CPPUNIT_HEADERS)
    MESSAGE("-- Looking for Cppunit - found")
  ELSE ( CPPUNIT AND CPPUNIT_HEADERS )
    MESSAGE( FATAL_ERROR "-- Looking for Cppunit - not found")
  ENDIF ( CPPUNIT AND CPPUNIT_HEADERS )
ENDIF(ENABLE_TESTS )

OPTION(ENABLE_EXAMPLES OFF "Enable building of examples")

ADD_SUBDIRECTORY( doc )
ADD_SUBDIRECTORY( src )
ADD_SUBDIRECTORY( tests )
ADD_SUBDIRECTORY( models )
ADD_SUBDIRECTORY( examples )


export(TARGETS orocos-kdl
  FILE "${PROJECT_BINARY_DIR}/OrocosKDLTargets.cmake")

export(PACKAGE orocos_kdl)

set(KDL_INCLUDE_DIRS ${KDL_INCLUDE_DIRS} ${Eigen_INCLUDE_DIR})

CONFIGURE_FILE(KDLConfig.cmake.in
  ${PROJECT_BINARY_DIR}/orocos_kdl-config.cmake @ONLY)
CONFIGURE_FILE(KDLConfigVersion.cmake.in
  ${PROJECT_BINARY_DIR}/orocos_kdl-config-version.cmake @ONLY)

INSTALL(FILES ${PROJECT_BINARY_DIR}/orocos_kdl-config.cmake DESTINATION share/orocos_kdl)
INSTALL(FILES ${PROJECT_BINARY_DIR}/orocos_kdl-config-version.cmake DESTINATION share/orocos_kdl)
INSTALL(EXPORT OrocosKDLTargets DESTINATION share/orocos_kdl)

INSTALL(FILES package.xml DESTINATION share/orocos_kdl)

=== debian/control ===
--- 
+++ 
@@ -3,11 +3,11 @@
 Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Leopold Palomo-Avellaneda <leo@alaxarxa.net>, Riku Voipio <riku.voipio@linaro.org>
 Build-Depends: debhelper (>= 9), cmake (>=2.6.0), pkg-config, libeigen3-dev
-Standards-Version: 3.9.6
+Standards-Version: 3.9.8
 Section: libs
 Homepage: http://www.orocos.org/kdl
-Vcs-Browser: http://anonscm.debian.org/gitweb/?p=debian-science/packages/orocos/orocos-kdl.git
-Vcs-Git: git://anonscm.debian.org/debian-science/packages/orocos/orocos-kdl.git
+Vcs-Browser: https://anonscm.debian.org/git/debian-science/packages/orocos/orocos-kdl.git
+Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/orocos/orocos-kdl.git
 
 Package: liborocos-kdl-dev
 Section: libdevel

## orocos-kdl 1.4.0

=== orocos_kdl/CMakeLists.txt ===
--- 
+++ 
@@ -13,13 +13,13 @@
 
 PROJECT(orocos_kdl)
 
-SET( KDL_VERSION 1.3.0)
+SET( KDL_VERSION 1.4.0)
 STRING( REGEX MATCHALL "[0-9]+" KDL_VERSIONS ${KDL_VERSION} )
 LIST( GET KDL_VERSIONS 0 KDL_VERSION_MAJOR)
 LIST( GET KDL_VERSIONS 1 KDL_VERSION_MINOR)
 LIST( GET KDL_VERSIONS 2 KDL_VERSION_PATCH)
 
-MESSAGE( "Orocos KDL version ${VERSION} (${KDL_VERSION_MAJOR}.${KDL_VERSION_MINOR}.${KDL_VERSION_PATCH})" )
+MESSAGE( STATUS "Orocos KDL version ${VERSION} (${KDL_VERSION_MAJOR}.${KDL_VERSION_MINOR}.${KDL_VERSION_PATCH})" )
 
 SET( PROJ_SOURCE_DIR ${orocos_kdl_SOURCE_DIR} )
 SET( PROJ_BINARY_DIR ${orocos_kdl_BINARY_DIR} )
@@ -35,9 +35,9 @@
 
 IF ( NOT CMAKE_BUILD_TYPE )
   SET(CMAKE_BUILD_TYPE Release CACHE STRING "Choose the type of build, options are: None(CMAKE_CXX_FLAGS or CMAKE_C_FLAGS used) Debug Release RelWithDebInfo MinSizeRel." FORCE)
-  MESSAGE( "Setting build type to '${CMAKE_BUILD_TYPE}'" )
+  MESSAGE( STATUS "Setting build type to '${CMAKE_BUILD_TYPE}'" )
 ELSE ( NOT CMAKE_BUILD_TYPE )
-  MESSAGE( "Build type set to '${CMAKE_BUILD_TYPE}' by user." )
+  MESSAGE( STATUS "Build type set to '${CMAKE_BUILD_TYPE}' by user." )
 ENDIF ( NOT CMAKE_BUILD_TYPE )
 
 SET( KDL_CFLAGS "")
@@ -45,7 +45,7 @@
 find_package(Eigen 3 QUIET)
 if(NOT Eigen_FOUND)
   include(${PROJ_SOURCE_DIR}/config/FindEigen3.cmake)
-  set(Eigen_INCLUDE_DIR ${EIGEN3_INCLUDE_DIR})
+  set(Eigen_INCLUDE_DIR "${EIGEN3_INCLUDE_DIR}")
 endif()
 include_directories(${Eigen_INCLUDE_DIR})
 SET(KDL_CFLAGS "${KDL_CFLAGS} -I${Eigen_INCLUDE_DIR}")
@@ -83,7 +83,7 @@
   SET(CPPUNIT ${CPPUNIT} "dl")
   FIND_PATH(CPPUNIT_HEADERS cppunit/TestRunner.h)
   IF ( CPPUNIT AND CPPUNIT_HEADERS)
-    MESSAGE("-- Looking for Cppunit - found")
+    MESSAGE( STATUS "-- Looking for Cppunit - found")
   ELSE ( CPPUNIT AND CPPUNIT_HEADERS )
     MESSAGE( FATAL_ERROR "-- Looking for Cppunit - not found")
   ENDIF ( CPPUNIT AND CPPUNIT_HEADERS )
@@ -110,8 +110,8 @@
 CONFIGURE_FILE(KDLConfigVersion.cmake.in
   ${PROJECT_BINARY_DIR}/orocos_kdl-config-version.cmake @ONLY)
 
-INSTALL(FILES ${PROJECT_BINARY_DIR}/orocos_kdl-config.cmake DESTINATION share/orocos_kdl)
-INSTALL(FILES ${PROJECT_BINARY_DIR}/orocos_kdl-config-version.cmake DESTINATION share/orocos_kdl)
-INSTALL(EXPORT OrocosKDLTargets DESTINATION share/orocos_kdl)
+INSTALL(FILES ${PROJECT_BINARY_DIR}/orocos_kdl-config.cmake DESTINATION share/orocos_kdl/cmake)
+INSTALL(FILES ${PROJECT_BINARY_DIR}/orocos_kdl-config-version.cmake DESTINATION share/orocos_kdl/cmake)
+INSTALL(EXPORT OrocosKDLTargets DESTINATION share/orocos_kdl/cmake)
 
 INSTALL(FILES package.xml DESTINATION share/orocos_kdl)

=== orocos_kinematics_dynamics/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)
project(orocos_kinematics_dynamics)
find_package(catkin REQUIRED)
catkin_metapackage()

=== python_orocos_kdl/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.4.6)

project(python_orocos_kdl)

find_package(orocos_kdl)
include_directories(${orocos_kdl_INCLUDE_DIRS})
link_directories(${orocos_kdl_LIBRARY_DIRS})

SET(PYTHON_VERSION 2 CACHE STRING "Python Version")
find_package(PythonInterp ${PYTHON_VERSION} REQUIRED)
find_package(PythonLibs ${PYTHON_VERSION_MAJOR}.${PYTHON_VERSION_MINOR} REQUIRED)
execute_process(COMMAND ${PYTHON_EXECUTABLE} -c "from distutils.sysconfig import get_python_lib; print(get_python_lib(plat_specific=True, prefix=''))" OUTPUT_VARIABLE PYTHON_SITE_PACKAGES OUTPUT_STRIP_TRAILING_WHITESPACE)
list(APPEND CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake)
find_package(SIP REQUIRED)
include(SIPMacros)

include_directories(${SIP_INCLUDE_DIR} ${PYTHON_INCLUDE_DIRS})

file(GLOB SIP_FILES "${CMAKE_CURRENT_SOURCE_DIR}/*.sip")
set(SIP_INCLUDES ${SIP_FILES})
set(SIP_EXTRA_OPTIONS "-o")
set(PYTHON_SITE_PACKAGES_INSTALL_DIR ${CMAKE_INSTALL_PREFIX}/${PYTHON_SITE_PACKAGES})
add_sip_python_module(PyKDL PyKDL/PyKDL.sip ${orocos_kdl_LIBRARIES})

install(FILES package.xml DESTINATION share/python_orocos_kdl)

=== orocos_kdl/doc/CMakeLists.txt ===

CONFIGURE_FILE("${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in" "${CMAKE_CURRENT_BINARY_DIR}/Doxyfile" IMMEDIATE @ONLY)
ADD_CUSTOM_TARGET(docs "doxygen" "Doxyfile")
INSTALL(FILES ${CMAKE_CURRENT_BINARY_DIR}/kdl.tag DESTINATION share/doc/liborocos-kdl/ OPTIONAL) # only installs if found.

=== orocos_kdl/src/CMakeLists.txt ===
--- 
+++ 
@@ -61,15 +61,69 @@
 
 CONFIGURE_FILE(config.h.in config.h @ONLY)
 
+#### Settings for rpath
+IF(${CMAKE_MINIMUM_REQUIRED_VERSION} VERSION_GREATER "2.8.12")
+    MESSAGE(AUTHOR_WARNING "CMAKE_MINIMUM_REQUIRED_VERSION is now ${CMAKE_MINIMUM_REQUIRED_VERSION}. This check can be removed.")
+ENDIF()
+IF(NOT (CMAKE_VERSION VERSION_LESS 2.8.12))
+    IF(NOT MSVC)
+        #add the option to disable RPATH
+        OPTION(OROCOSKDL_ENABLE_RPATH "Enable RPATH during installation" TRUE)
+        MARK_AS_ADVANCED(OROCOSKDL_ENABLE_RPATH)
+    ENDIF(NOT MSVC)
+
+    IF(OROCOSKDL_ENABLE_RPATH)
+        #Configure RPATH
+        SET(CMAKE_MACOSX_RPATH TRUE) #enable RPATH on OSX. This also suppress warnings on CMake >= 3.0
+        # when building, don't use the install RPATH already
+        # (but later on when installing)
+        SET(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE)
+        #build directory by default is built with RPATH
+        SET(CMAKE_SKIP_BUILD_RPATH  FALSE)
+
+        #This is relative RPATH for libraries built in the same project
+        #I assume that the directory is
+        # - install_dir/something for binaries
+        # - install_dir/lib for libraries
+        LIST(FIND CMAKE_PLATFORM_IMPLICIT_LINK_DIRECTORIES "${CMAKE_INSTALL_PREFIX}/lib" isSystemDir)
+        IF("${isSystemDir}" STREQUAL "-1")
+            FILE(RELATIVE_PATH _rel_path "${CMAKE_INSTALL_PREFIX}/bin" "${CMAKE_INSTALL_PREFIX}/lib")
+            IF (${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
+                SET(CMAKE_INSTALL_RPATH "@loader_path/${_rel_path}")
+            ELSE()
+                SET(CMAKE_INSTALL_RPATH "\$ORIGIN/${_rel_path}")
+            ENDIF()
+        ENDIF("${isSystemDir}" STREQUAL "-1")
+        # add the automatically determined parts of the RPATH
+        # which point to directories outside the build tree to the install RPATH
+        SET(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE) #very important!
+    ENDIF()
+ENDIF()
+#####end RPATH
+
 ADD_LIBRARY(orocos-kdl ${LIB_TYPE} ${KDL_SRCS} config.h)
- 
+
 SET_TARGET_PROPERTIES( orocos-kdl PROPERTIES
   SOVERSION "${KDL_VERSION_MAJOR}.${KDL_VERSION_MINOR}"
   VERSION "${KDL_VERSION}"
   COMPILE_FLAGS "${CMAKE_CXX_FLAGS_ADD} ${KDL_CFLAGS}"
-  INSTALL_NAME_DIR "${CMAKE_INSTALL_PREFIX}/lib${LIB_SUFFIX}"
   PUBLIC_HEADER "${KDL_HPPS};${CMAKE_CURRENT_BINARY_DIR}/config.h"
   )
+
+#### Settings for rpath disabled (back-compatibility)
+IF(${CMAKE_MINIMUM_REQUIRED_VERSION} VERSION_GREATER "2.8.12")
+    MESSAGE(AUTHOR_WARNING "CMAKE_MINIMUM_REQUIRED_VERSION is now ${CMAKE_MINIMUM_REQUIRED_VERSION}. This check can be removed.")
+ENDIF()
+IF(CMAKE_VERSION VERSION_LESS 2.8.12)
+    SET_TARGET_PROPERTIES( orocos-kdl PROPERTIES
+      INSTALL_NAME_DIR "${CMAKE_INSTALL_PREFIX}/lib${LIB_SUFFIX}")
+ELSE()
+    IF(NOT OROCOSKDL_ENABLE_RPATH)
+        SET_TARGET_PROPERTIES( orocos-kdl PROPERTIES
+          INSTALL_NAME_DIR "${CMAKE_INSTALL_PREFIX}/lib${LIB_SUFFIX}")
+    ENDIF()
+ENDIF()
+#####end RPATH
 
 # Needed so that the generated config.h can be used
 INCLUDE_DIRECTORIES(${CMAKE_CURRENT_BINARY_DIR})

=== orocos_kdl/tests/CMakeLists.txt ===
--- 
+++ 
@@ -38,6 +38,13 @@
   COMPILE_FLAGS "${CMAKE_CXX_FLAGS_ADD} ${KDL_CFLAGS} -DTESTNAME=\"\\\"${TESTNAME}\\\"\" ")
  ADD_TEST(jacobiantest jacobiantest)
 
+ ADD_EXECUTABLE(jacobiandottest jacobiandottest.cpp test-runner.cpp)
+ SET(TESTNAME "jacobiandottest")
+ TARGET_LINK_LIBRARIES(jacobiandottest orocos-kdl ${CPPUNIT})
+ SET_TARGET_PROPERTIES( jacobiandottest PROPERTIES
+  COMPILE_FLAGS "${CMAKE_CXX_FLAGS_ADD} ${KDL_CFLAGS} -DTESTNAME=\"\\\"${TESTNAME}\\\"\" ")
+ ADD_TEST(jacobiandottest jacobiandottest)
+ 
  ADD_EXECUTABLE(velocityprofiletest velocityprofiletest.cpp test-runner.cpp)
  SET(TESTNAME "velocityprofiletest")
  TARGET_LINK_LIBRARIES(velocityprofiletest orocos-kdl ${CPPUNIT})

=== debian/changelog ===
orocos-kdl (1.4.0-7ubuntu1) focal; urgency=medium

  * Add patch for python3 std string conversion (LP: #1871725)

 -- Jochen Sprickerhof <jspricke@debian.org>  Thu, 09 Apr 2020 18:46:55 +0200

orocos-kdl (1.4.0-7build2) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 23 Mar 2020 07:22:18 +0100

orocos-kdl (1.4.0-7build1) focal; urgency=medium

  * No-change rebuild to build with python3.8.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 25 Jan 2020 04:37:51 +0000

orocos-kdl (1.4.0-7) unstable; urgency=medium

  * Add missing dependency (Closes: #913803)
  * Fix typo in changelog

 -- Jochen Sprickerhof <jspricke@debian.org>  Mon, 19 Nov 2018 22:31:27 +0100

orocos-kdl (1.4.0-6) unstable; urgency=medium

  * Team upload.
  * Do not build-depend on all support python(3) versions, since the build
    system only builds for the default one.
  * Mark liborocos-kdl-dev and python3-pykdl as Multi-Arch:same
    (from the m-a hinter).
  * Remove obsolete DEB_EXPORT_BUILDFLAGS from d/rules, covered by dh nowadays.

 -- Mattia Rizzolo <mattia@debian.org>  Thu, 27 Sep 2018 13:48:52 +0200

orocos-kdl (1.4.0-5) unstable; urgency=medium

  [ Johannes 'josch' Schauer ]
  * add autopkgtest
  * add missing dependency of liborocos-kdl-dev on libeigen3-dev
  * debian/tests/compilation: Don't forget to add include directories

  [ Jochen Sprickerhof ]
  * Fix in tree compilation patch (Closes: #907827)
  * Bump policy version (no changes)
  * Fix pkgconfig path
  * http -> https

 -- Jochen Sprickerhof <jspricke@debian.org>  Fri, 14 Sep 2018 08:38:57 +0200

orocos-kdl (1.4.0-4) unstable; urgency=medium

  * Add patch to fix the cmake files (Closes: #898883)

 -- Jochen Sprickerhof <jspricke@debian.org>  Sat, 19 May 2018 18:36:18 +0200

orocos-kdl (1.4.0-3) unstable; urgency=medium

  * Upload to unstable

 -- Jochen Sprickerhof <jspricke@debian.org>  Sun, 13 May 2018 13:02:18 +0200

orocos-kdl (1.4.0-2) experimental; urgency=medium

  * Update watch file
  * Don't exclude files anymore
  * New upstream version 1.4.0
  * Update copyright
  * Rebase patches
  * Adopt to Soname bump
  * Bump policy and debhelper versions
  * Add R³
  * Update Vcs URLs to salsa.d.o
  * Add myself to uploaders
  * Add python3-pykdl package

 -- Jochen Sprickerhof <jspricke@debian.org>  Mon, 23 Apr 2018 20:59:11 +0200

=== debian/control ===
Source: orocos-kdl
Section: libs
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Leopold Palomo-Avellaneda <leo@alaxarxa.net>, Riku Voipio <riku.voipio@linaro.org>, Jochen Sprickerhof <jspricke@debian.org>,
Build-Depends: debhelper (>= 11), cmake, pkg-config, libeigen3-dev, python3-dev, dh-python, python3-sip-dev
Standards-Version: 4.2.1
Rules-Requires-Root: no
Homepage: http://www.orocos.org/kdl
Vcs-Browser: https://salsa.debian.org/science-team/orocos-kdl
Vcs-Git: https://salsa.debian.org/science-team/orocos-kdl.git

Package: liborocos-kdl-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: liborocos-kdl1.4 (= ${binary:Version}), ${misc:Depends}, libeigen3-dev
Description: Kinematics and Dynamics Library development files
 Orocos project to supply RealTime usable kinematics and dynamics code,
 it contains code for rigid body kinematics calculations and
 representations for kinematic structures and their inverse and forward
 kinematic solvers. This package contains the development files
 of the library.

Package: liborocos-kdl1.4
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Kinematics and Dynamics Library runtime
 Orocos project to supply RealTime usable kinematics and dynamics code,
 it contains code for rigid body kinematics calculations and
 representations for kinematic structures and their inverse and forward
 kinematic solvers. This package contains the library itself.

Package: python3-pykdl
Section: python
Architecture: any
Multi-Arch: same
Depends: ${python3:Depends}, ${shlibs:Depends}, ${misc:Depends}, python3-sip
Description: Kinematics and Dynamics Library Python library
 This package contains the Python bindings PyKDL for the Kinematics and
 Dynamics Library (KDL), distributed by the Orocos Project.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

%:
	dh $@ --buildsystem=cmake --with python3

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%orocos-kdl-$1.tar.gz%" \
    https://github.com/orocos/orocos_kinematics_dynamics/tags \
    (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate

## orocos-kdl 1.5.1

=== orocos_kdl/CMakeLists.txt ===
--- 
+++ 
@@ -2,6 +2,9 @@
 # Test CMake version
 #
 CMAKE_MINIMUM_REQUIRED(VERSION 2.6)
+IF(POLICY CMP0048)
+  CMAKE_POLICY(SET CMP0048 NEW)
+ENDIF()
 #MARK_AS_ADVANCED( FORCE CMAKE_BACKWARDS_COMPATIBILITY )
 
 
@@ -13,7 +16,7 @@
 
 PROJECT(orocos_kdl)
 
-SET( KDL_VERSION 1.4.0)
+SET( KDL_VERSION 1.5.1)
 STRING( REGEX MATCHALL "[0-9]+" KDL_VERSIONS ${KDL_VERSION} )
 LIST( GET KDL_VERSIONS 0 KDL_VERSION_MAJOR)
 LIST( GET KDL_VERSIONS 1 KDL_VERSION_MINOR)
@@ -24,6 +27,14 @@
 SET( PROJ_SOURCE_DIR ${orocos_kdl_SOURCE_DIR} )
 SET( PROJ_BINARY_DIR ${orocos_kdl_BINARY_DIR} )
 
+# catkin-specific configuration (optional)
+find_package(catkin QUIET)
+if(catkin_FOUND)
+  catkin_package(
+    SKIP_CMAKE_CONFIG_GENERATION
+    SKIP_PKG_CONFIG_GENERATION
+  )
+endif()
 
 IF(NOT CMAKE_INSTALL_PREFIX)
   SET( CMAKE_INSTALL_PREFIX /usr/local/ CACHE PATH "Installation directory" FORCE)
@@ -42,37 +53,39 @@
 
 SET( KDL_CFLAGS "")
 
-find_package(Eigen 3 QUIET)
-if(NOT Eigen_FOUND)
-  include(${PROJ_SOURCE_DIR}/config/FindEigen3.cmake)
-  set(Eigen_INCLUDE_DIR "${EIGEN3_INCLUDE_DIR}")
+find_package(Eigen3 QUIET)
+if(NOT EIGEN3_FOUND)
+  include(${PROJ_SOURCE_DIR}/cmake/FindEigen3.cmake)
 endif()
-include_directories(${Eigen_INCLUDE_DIR})
-SET(KDL_CFLAGS "${KDL_CFLAGS} -I${Eigen_INCLUDE_DIR}")
+include_directories(${EIGEN3_INCLUDE_DIR})
+SET(KDL_CFLAGS "${KDL_CFLAGS} -I${EIGEN3_INCLUDE_DIR}")
 
 # Check the platform STL containers capabilities
-include(config/CheckSTLContainers.cmake)
+include(cmake/CheckSTLContainers.cmake)
 CHECK_STL_CONTAINERS()
 
 # Set the default option appropriately
 if(HAVE_STL_CONTAINER_INCOMPLETE_TYPES)
-    set(KDL_USE_NEW_TREE_INTERFACE_DEFAULT Off)
+    set(KDL_USE_NEW_TREE_INTERFACE_DEFAULT OFF)
 else(HAVE_STL_CONTAINER_INCOMPLETE_TYPES)
-    set(KDL_USE_NEW_TREE_INTERFACE_DEFAULT On)
+    set(KDL_USE_NEW_TREE_INTERFACE_DEFAULT ON)
 endif(HAVE_STL_CONTAINER_INCOMPLETE_TYPES)
 
 # Allow the user to select the Tree API version to use
 set(KDL_USE_NEW_TREE_INTERFACE ${KDL_USE_NEW_TREE_INTERFACE_DEFAULT} CACHE BOOL "Use the new KDL Tree interface")
+
+#Sanity check, inform the user
+if(NOT HAVE_STL_CONTAINER_INCOMPLETE_TYPES AND NOT KDL_USE_NEW_TREE_INTERFACE)
+    message(WARNING "You have chosen to use the current Tree Interface, but your platform doesn't support containers of "
+        "incomplete types, this configuration is likely invalid")
+endif()
 
 # The new interface requires the use of shared pointers
 if(KDL_USE_NEW_TREE_INTERFACE)
     # We need shared_ptr from boost since not all compilers are c++11 capable
     find_package(Boost REQUIRED)
     include_directories(${Boost_INCLUDE_DIRS})
-    set(KDL_INCLUDE_DIRS ${Boost_INCLUDE_DIRS})
 endif(KDL_USE_NEW_TREE_INTERFACE)
-
-INCLUDE (${PROJ_SOURCE_DIR}/config/DependentOption.cmake)
 
 OPTION(ENABLE_TESTS OFF "Enable building of tests")
 IF( ENABLE_TESTS )
@@ -103,15 +116,20 @@
 
 export(PACKAGE orocos_kdl)
 
-set(KDL_INCLUDE_DIRS ${KDL_INCLUDE_DIRS} ${Eigen_INCLUDE_DIR})
-
-CONFIGURE_FILE(KDLConfig.cmake.in
+# Generate CMake package configuration
+CONFIGURE_FILE(orocos_kdl-config.cmake.in
   ${PROJECT_BINARY_DIR}/orocos_kdl-config.cmake @ONLY)
-CONFIGURE_FILE(KDLConfigVersion.cmake.in
+CONFIGURE_FILE(orocos_kdl-config-version.cmake.in
   ${PROJECT_BINARY_DIR}/orocos_kdl-config-version.cmake @ONLY)
 
+INSTALL(FILES cmake/FindEigen3.cmake DESTINATION share/orocos_kdl/cmake)
 INSTALL(FILES ${PROJECT_BINARY_DIR}/orocos_kdl-config.cmake DESTINATION share/orocos_kdl/cmake)
 INSTALL(FILES ${PROJECT_BINARY_DIR}/orocos_kdl-config-version.cmake DESTINATION share/orocos_kdl/cmake)
 INSTALL(EXPORT OrocosKDLTargets DESTINATION share/orocos_kdl/cmake)
 
-INSTALL(FILES package.xml DESTINATION share/orocos_kdl)
+# Generate pkg-config package configuration
+CONFIGURE_FILE(orocos_kdl.pc.in ${CMAKE_CURRENT_BINARY_DIR}/orocos-kdl.pc @ONLY)
+CONFIGURE_FILE(orocos_kdl.pc.in ${CMAKE_CURRENT_BINARY_DIR}/orocos_kdl.pc @ONLY)
+
+INSTALL(FILES ${CMAKE_CURRENT_BINARY_DIR}/orocos-kdl.pc DESTINATION lib${LIB_SUFFIX}/pkgconfig)
+INSTALL(FILES ${CMAKE_CURRENT_BINARY_DIR}/orocos_kdl.pc DESTINATION lib${LIB_SUFFIX}/pkgconfig)

=== python_orocos_kdl/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0.2)
if(POLICY CMP0048)
  cmake_policy(SET CMP0048 NEW)
endif()
if(POLICY CMP0057)
  cmake_policy(SET CMP0057 NEW)  # support IN_LISTS which is required for PyBind11 2.6 and newer
endif()

project(python_orocos_kdl VERSION 1.5.1)

# find a matching version of orocos_kdl
find_package(orocos_kdl ${PROJECT_VERSION} EXACT REQUIRED)
include_directories(${orocos_kdl_INCLUDE_DIRS})
link_directories(${orocos_kdl_LIBRARY_DIRS})

if(DEFINED ENV{ROS_PYTHON_VERSION})
  SET(PYTHON_VERSION $ENV{ROS_PYTHON_VERSION} CACHE STRING "Python Version")
else()
  SET(PYTHON_VERSION 3 CACHE STRING "Python Version")
endif()

set(PYBIND11_PYTHON_VERSION ${PYTHON_VERSION} CACHE STRING "Python version used by PyBind11")

find_package(PythonInterp ${PYTHON_VERSION} REQUIRED)
find_package(PythonLibs ${PYTHON_VERSION_MAJOR}.${PYTHON_VERSION_MINOR} REQUIRED)
# get_python_lib in python3 produces path which isn't in sys.path: https://bugs.launchpad.net/ubuntu/+source/python3-stdlib-extensions/+bug/1832215
# execute_process(COMMAND ${PYTHON_EXECUTABLE} -c "from distutils.sysconfig import get_python_lib; print(get_python_lib(plat_specific=True, prefix=''))" OUTPUT_VARIABLE PYTHON_SITE_PACKAGES OUTPUT_STRIP_TRAILING_WHITESPACE)
set(PYTHON_SITE_PACKAGES_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/lib/python${PYTHON_VERSION_MAJOR}.${PYTHON_VERSION_MINOR}/dist-packages")  # This might be overridden below if built with catkin.
set(LIBRARY_NAME "PyKDL")

# catkin-specific configuration (optional)
find_package(catkin QUIET)
if(catkin_FOUND)
  catkin_package(
    SKIP_CMAKE_CONFIG_GENERATION
    SKIP_PKG_CONFIG_GENERATION
  )
  set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CATKIN_DEVEL_PREFIX}/${PYTHON_INSTALL_DIR})
  set(PYTHON_SITE_PACKAGES_INSTALL_DIR "${PYTHON_INSTALL_DIR}")
endif()

# Build the module
if(WIN32)
  set(PYTHON_MODULE_EXTENSION ".pyd")
else()
  set(PYTHON_MODULE_EXTENSION ".so")
endif()

add_subdirectory(pybind11)
pybind11_add_module(${LIBRARY_NAME}
  PyKDL/PyKDL.h
  PyKDL/PyKDL.cpp
  PyKDL/frames.cpp
  PyKDL/kinfam.cpp
  PyKDL/framevel.cpp
  PyKDL/dynamics.cpp)
target_link_libraries(${LIBRARY_NAME} PRIVATE ${orocos_kdl_LIBRARIES})
install(TARGETS ${LIBRARY_NAME} DESTINATION "${PYTHON_SITE_PACKAGES_INSTALL_DIR}")

=== orocos_kdl/src/CMakeLists.txt ===
--- 
+++ 
@@ -2,52 +2,6 @@
 FILE( GLOB KDL_HPPS [^.]*.hpp [^.]*.inl)
 
 FILE( GLOB UTIL_HPPS utilities/[^.]*.h utilities/[^.]*.hpp)
-
-INCLUDE(CheckCXXSourceCompiles)
-SET(CMAKE_REQUIRED_FLAGS)
-CHECK_CXX_SOURCE_COMPILES("
-    #include <string>
-    #include <map>
-    #include <vector.hpp>
-
-    class TreeElement;
-    typedef std::map<std::string, TreeElement> SegmentMap;
-
-    class TreeElement
-    {
-        TreeElement(const std::string& name): number(0) {}
-
-    public:
-        int number;
-        SegmentMap::const_iterator parent;
-        std::vector<SegmentMap::const_iterator> children;
-
-        static TreeElement Root(std::string& name)
-        {
-            return TreeElement(name);
-        }
-    };
-
-    int main()
-    {
-        return 0;
-    }
-    "
-    HAVE_STL_CONTAINER_INCOMPLETE_TYPES)
-
-if(HAVE_STL_CONTAINER_INCOMPLETE_TYPES)
-    SET(KDL_USE_NEW_TREE_INTERFACE_DEFAULT Off)
-ELSE(HAVE_STL_CONTAINER_INCOMPLETE_TYPES)
-    SET(KDL_USE_NEW_TREE_INTERFACE_DEFAULT On)
-ENDIF(HAVE_STL_CONTAINER_INCOMPLETE_TYPES)
-
-SET(KDL_USE_NEW_TREE_INTERFACE ${KDL_USE_NEW_TREE_INTERFACE_DEFAULT} CACHE BOOL "Use the new KDL Tree interface")
-
-#Sanity check, inform the user
-IF(NOT HAVE_STL_CONTAINER_INCOMPLETE_TYPES AND NOT KDL_USE_NEW_TREE_INTERFACE)
-    MESSAGE(WARNING "You have chosen to use the current Tree Interface, but your platform doesn't support containers of "
-        "incomplete types, this configuration is likely invalid")
-ENDIF()
 
 #In Windows (Visual Studio) it is necessary to specify the postfix
 #of the debug library name and no symbols are exported by kdl, 
@@ -133,14 +87,8 @@
   EXPORT OrocosKDLTargets
   ARCHIVE DESTINATION lib${LIB_SUFFIX}
   LIBRARY DESTINATION lib${LIB_SUFFIX}
+  RUNTIME DESTINATION bin
   PUBLIC_HEADER DESTINATION include/kdl
 )
 
 INSTALL(FILES ${UTIL_HPPS} DESTINATION include/kdl/utilities)
-
-# Orocos convention:
-CONFIGURE_FILE( kdl.pc.in ${CMAKE_CURRENT_BINARY_DIR}/orocos-kdl.pc @ONLY)
-CONFIGURE_FILE( kdl.pc.in ${CMAKE_CURRENT_BINARY_DIR}/orocos_kdl.pc @ONLY)
-
-INSTALL(FILES ${CMAKE_CURRENT_BINARY_DIR}/orocos-kdl.pc DESTINATION lib${LIB_SUFFIX}/pkgconfig)
-INSTALL(FILES ${CMAKE_CURRENT_BINARY_DIR}/orocos_kdl.pc DESTINATION lib${LIB_SUFFIX}/pkgconfig)

=== orocos_kdl/tests/CMakeLists.txt ===
--- 
+++ 
@@ -9,7 +9,7 @@
   SET_TARGET_PROPERTIES( framestest PROPERTIES
    COMPILE_FLAGS "${CMAKE_CXX_FLAGS_ADD} ${KDL_CFLAGS} -DTESTNAME=\"\\\"${TESTNAME}\\\"\" ")
   ADD_TEST(framestest framestest)
-  
+
  ADD_EXECUTABLE(kinfamtest kinfamtest.cpp test-runner.cpp)
  TARGET_LINK_LIBRARIES(kinfamtest orocos-kdl ${CPPUNIT})
  SET(TESTNAME "kinfamtest")
@@ -44,13 +44,20 @@
  SET_TARGET_PROPERTIES( jacobiandottest PROPERTIES
   COMPILE_FLAGS "${CMAKE_CXX_FLAGS_ADD} ${KDL_CFLAGS} -DTESTNAME=\"\\\"${TESTNAME}\\\"\" ")
  ADD_TEST(jacobiandottest jacobiandottest)
- 
+
  ADD_EXECUTABLE(velocityprofiletest velocityprofiletest.cpp test-runner.cpp)
  SET(TESTNAME "velocityprofiletest")
  TARGET_LINK_LIBRARIES(velocityprofiletest orocos-kdl ${CPPUNIT})
  SET_TARGET_PROPERTIES( velocityprofiletest PROPERTIES
    COMPILE_FLAGS "${CMAKE_CXX_FLAGS_ADD} ${KDL_CFLAGS} -DTESTNAME=\"\\\"${TESTNAME}\\\"\" ")
  ADD_TEST(velocityprofiletest velocityprofiletest)
+
+ ADD_EXECUTABLE(treeinvdyntest treeinvdyntest.cpp test-runner.cpp)
+ SET(TESTNAME "treeinvdyntest")
+ TARGET_LINK_LIBRARIES(treeinvdyntest orocos-kdl ${CPPUNIT})
+ SET_TARGET_PROPERTIES( treeinvdyntest PROPERTIES
+   COMPILE_FLAGS "${CMAKE_CXX_FLAGS_ADD} ${KDL_CFLAGS} -DTESTNAME=\"\\\"${TESTNAME}\\\"\" ")
+ ADD_TEST(treeinvdyntest treeinvdyntest)
 
 #  ADD_EXECUTABLE(rframestest  rframestest.cpp)
 #  TARGET_LINK_LIBRARIES(rframestest orocos-kdl)
@@ -59,29 +66,6 @@
 #  ADD_EXECUTABLE(rallnumbertest  rallnumbertest.cpp)
 #  TARGET_LINK_LIBRARIES(rallnumbertest orocos-kdl)
 #  ADD_TEST(rallnumbertest rallnumbertest)
-#
-#  
-# IF(OROCOS_PLUGIN)
-#   ADD_EXECUTABLE(toolkittest toolkittest.cpp)
-#   LINK_DIRECTORIES(${OROCOS_RTT_LINK_DIRS})
-#   TARGET_LINK_LIBRARIES(toolkittest orocos-kdltk orocos-kdl ${OROCOS_RTT_LIBS})
-#   ADD_TEST(toolkittest toolkittest)
-# ENDIF(OROCOS_PLUGIN)
-#
-# IF(PYTHON_BINDINGS)
-#   CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/framestest.py
-#     ${CMAKE_CURRENT_BINARY_DIR}/framestest.py COPY_ONLY)
-#   CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/kinfamtest.py
-#     ${CMAKE_CURRENT_BINARY_DIR}/kinfamtest.py COPY_ONLY)
-#   CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/frameveltest.py
-#     ${CMAKE_CURRENT_BINARY_DIR}/frameveltest.py COPY_ONLY)
-#   CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/PyKDLtest.py
-#     ${CMAKE_CURRENT_BINARY_DIR}/PyKDLtest.py COPY_ONLY)
-#   ADD_TEST(PyKDLtest PyKDLtest.py)
-#   
-#  
-# ENDIF(PYTHON_BINDINGS)
-  
+
   ADD_CUSTOM_TARGET(check ctest -V WORKING_DIRECTORY ${PROJ_BINARY_DIR}/tests)
-ENDIF(ENABLE_TESTS)  
-
+ENDIF(ENABLE_TESTS)

=== debian/changelog ===
orocos-kdl (1.5.1-4build4) resolute; urgency=medium

  * No-change rebuild with Python 3.14 as supported version

 -- Graham Inggs <ginggs@ubuntu.com>  Sat, 18 Oct 2025 13:31:19 +0000

orocos-kdl (1.5.1-4build3) plucky; urgency=medium

  * No-change rebuild with Python 3.13 only

 -- Graham Inggs <ginggs@ubuntu.com>  Tue, 04 Mar 2025 22:37:15 +0000

orocos-kdl (1.5.1-4build2) plucky; urgency=medium

  * SRU: #2083480: No-change rebuild to add support for Python 3.13.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 13 Nov 2024 10:01:59 +0100

orocos-kdl (1.5.1-4build1) noble; urgency=medium

  * No-change rebuild with Python 3.12 only

 -- Graham Inggs <ginggs@ubuntu.com>  Thu, 11 Apr 2024 11:14:22 +0000

orocos-kdl (1.5.1-4) unstable; urgency=medium

  * Drop unused sip dependencies

 -- Jochen Sprickerhof <jspricke@debian.org>  Tue, 09 Jan 2024 20:55:34 +0100

orocos-kdl (1.5.1-3) unstable; urgency=medium

  [ Jochen Sprickerhof ]
  * Update autopkgtest
  * Remove Riku from uploaders (thanks for your work!) (Closes: #1001565)
  * Use find_package(pybind11 CONFIG)
    Thanks to v4hn
  * Add upstream source
  * Bump policy version (no changes)

  [ Debian Janitor ]
  * Use secure URI in Homepage field.
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.
  * Replace use of deprecated $ADTTMP with $AUTOPKGTEST_TMP.

 -- Jochen Sprickerhof <jspricke@debian.org>  Thu, 06 Jul 2023 12:41:13 +0200

orocos-kdl (1.5.1-2) unstable; urgency=medium

  * upload to unstable

 -- Jochen Sprickerhof <jspricke@debian.org>  Sun, 10 Oct 2021 22:41:48 +0200

orocos-kdl (1.5.1-1) experimental; urgency=medium

  * New upstream version 1.5.1
  * Update copyright
  * Rebase patches
  * drop gitlab-ci
  * bump policy version (no changes)
  * Rename library package due to Soname bump
  * Use multi-arch dirs

 -- Jochen Sprickerhof <jspricke@debian.org>  Thu, 07 Oct 2021 15:14:58 +0200

orocos-kdl (1.4.0-11) unstable; urgency=medium

  * Add patch for include path

 -- Jochen Sprickerhof <jspricke@debian.org>  Fri, 11 Sep 2020 09:10:53 +0200

orocos-kdl (1.4.0-10) unstable; urgency=medium

  * Drop as-needed, done by default
  * Add patch for sip 4.19.23 (Closes: #963296)
  * bump debhelper version

 -- Jochen Sprickerhof <jspricke@debian.org>  Fri, 26 Jun 2020 17:28:06 +0200

orocos-kdl (1.4.0-9) unstable; urgency=medium

  * add Salsa CI
  * Add patch for python3 std string conversion (Closes: #956254)

 -- Jochen Sprickerhof <jspricke@debian.org>  Thu, 09 Apr 2020 16:36:15 +0200

orocos-kdl (1.4.0-8) unstable; urgency=medium

  * Support multiple Python version
  * bump policy and debhelper versions (no changes)

 -- Jochen Sprickerhof <jspricke@debian.org>  Mon, 06 Apr 2020 19:36:52 +0200

=== debian/control ===
Source: orocos-kdl
Section: libs
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Leopold Palomo-Avellaneda <leo@alaxarxa.net>, Jochen Sprickerhof <jspricke@debian.org>,
Build-Depends: debhelper-compat (= 13), cmake, pkg-config, libeigen3-dev, python3-all-dev, dh-sequence-python3, pybind11-dev
Standards-Version: 4.6.2
Rules-Requires-Root: no
Homepage: https://www.orocos.org/kdl
Vcs-Browser: https://salsa.debian.org/science-team/orocos-kdl
Vcs-Git: https://salsa.debian.org/science-team/orocos-kdl.git

Package: liborocos-kdl-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: liborocos-kdl1.5 (= ${binary:Version}), ${misc:Depends}, libeigen3-dev
Description: Kinematics and Dynamics Library development files
 Orocos project to supply RealTime usable kinematics and dynamics code,
 it contains code for rigid body kinematics calculations and
 representations for kinematic structures and their inverse and forward
 kinematic solvers. This package contains the development files
 of the library.

Package: liborocos-kdl1.5
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Kinematics and Dynamics Library runtime
 Orocos project to supply RealTime usable kinematics and dynamics code,
 it contains code for rigid body kinematics calculations and
 representations for kinematic structures and their inverse and forward
 kinematic solvers. This package contains the library itself.

Package: python3-pykdl
Section: python
Architecture: any
Multi-Arch: same
Depends: ${python3:Depends}, ${shlibs:Depends}, ${misc:Depends}
Description: Kinematics and Dynamics Library Python library
 This package contains the Python bindings PyKDL for the Kinematics and
 Dynamics Library (KDL), distributed by the Orocos Project.

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%orocos-kdl-$1.tar.gz%" \
    https://github.com/orocos/orocos_kinematics_dynamics/tags \
    (?:.*?/)?v?(\d[\d.]*)\.tar\.gz
